unit ShortestU;
{  This unit shows how simple it is to set up a fractal landscape. I've commented
 the objects created at design time.
   Basically, you need a SceneViewer, a Scene, a camera, a MaterialLibrary and
 a TerrainRenderer; make the latter child of a DummyCube if you want to be able
 to rescale it (to create wider perspective). All these objects must be linked
 properly as shown in other tutorials.

   This code just build and display a landscape. You can't navigate it nor rotate the angle
 of view.

                     Alexandre Hirzel, July 2003
 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLTerrainRenderer, GLObjects, GLTexture, GLMisc,
  GLWin32Viewer,
  ahGLrandomHDS; // Unit where the random landscape are coded

type
  TForm1 = class(TForm) // These are the minimum GLScene object needed.
                        // Built t design time
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLMaterialLibrary1: TGLMaterialLibrary; // Linked to the terrain renderer
    GLCamera1: TGLCamera; // Linked to the Scene Viewer
    GLDummyCube1: TGLDummyCube; // Contains the terrain renderer. Allows to change its scale
    GLTerrainRenderer1: TGLTerrainRenderer;
    procedure FormCreate(Sender: TObject);
  private
    hdsLandscape	:tGLFractalHDS; // Declare the landscape manually
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {Setting up terrain renderer. This could be done at design time but you have
   missed it. These transformations are needed because, in a HDS, the z vector
   is pointing upward.}
  GLTerrainRenderer1.Up.SetVector(0,0,1);
  GLTerrainRenderer1.Direction.SetVector(0,1,0);

  {Position the camera to have an interesting view}
  GLCamera1.Position.SetPoint(-64,16,64);

  {Creation and minimal set-up of a fractal landscape}
  hdsLandscape:=tGLFractalHDS.Create(Self);
  with hdsLandscape do begin
    TerrainRenderer:=GLTerrainRenderer1;
    Depth:=6; // Not needed but gives a nicer landscape (default depth is 4)
    Cyclic:=True; // Not needed but give a "infinite" landscape
    BuildLandscape; // Build a landscape with the default parameters
  end;//with
end;

end.
